<?php
/*
Plugin Name: WP-Insert YouTube Google Video
Plugin URI: http://briian.com/?p=821
Description: Quick insert YouTube or Google Videos in posts or comments. 此外掛可幫你在WordPress的文章或留言中，快速插入Google或YouTube影片。使用方法請參考：http://briian.com/?p=821
Version: 1.0.2
Author: J顤n Zaefferer and briian modified
Author URI: http://briian.com/?p=821
Instructions

Copy this file you unzipped into the wp-content/plugins folder of WordPress, 
then go to Administration > Plugins, it should be in the list. Activtate it 
and avery occurence of the expression [http://www.youtube.com/watch?v=YpSpjaUNLvM] (case unsensitive) will as
an embedded flash player. 
Author:J顤n Zaefferer http://bassistance.de/2006/04/12/wordpress-youtube-plugin/


使用方法：

在WordPress編輯視窗中(新文章 或留言迴響皆可)，直接加入：

[http://video.google.com/videoplay?docid=-1522689357011671730]

或  

[http://www.youtube.com/watch?v=EGX0RaLdVkI]  

即可。


注意！網址前後必須要有 [ 跟 ] 包圍起來，而且後面除了影片的ID之外，
不可插入其他參數或網址。此功能在WP中不管是所見即所得編輯模式，
或一般編輯模式，都可以使用。

範例：
正確：[http://video.google.com/videoplay?docid=-1522689357011671730]
錯誤：[http://video.google.com/videoplay?docid=-1522689357011671730&hl=en]

正確：[http://www.youtube.com/watch?v=YpSpjaUNLvM]
錯誤：[http://www.youtube.com/watch?v=YpSpjaUNLvM&eurl=http%3A%2F%2Fbriian%2Ecom%2F%3Fp%3D821]

此外掛由[不來恩]做了一些小修改，詳細說明請參考：http://briian.com/?p=821

*/

define("YOUTUBE_WIDTH", 425);
define("YOUTUBE_HEIGHT", 350);
define("GoogleVideo_WIDTH", 400);
define("GoogleVideo_HEIGHT", 326);
define("YOUTUBE_REGEXP", "/\[http\:\/\/.{2,3}.youtube.com\/watch\?v=([[:print:]]+)\]/");
define("YOUTUBE_TARGET", "<object type=\"application/x-shockwave-flash\" data=\"http://www.youtube.com/v/###URL###\" width=\"".YOUTUBE_WIDTH."\" height=\"".YOUTUBE_HEIGHT."\"><param name=\"movie\" value=\"http://www.youtube.com/v/###URL###\" /></object>");
define("GoogleVideo_REGEXP", "/\[http\:\/\/video.google.com\/videoplay\?docid=([[:print:]]+)\]/");
define("GoogleVideo_TARGET", "<object type=\"application/x-shockwave-flash\" data=\"http://video.google.com/googleplayer.swf?docId=###URL###\" width=\"".GoogleVideo_WIDTH."\" height=\"".GoogleVideo_HEIGHT."\"><param name=\"movie\" value=\"http://video.google.com/googleplayer.swf?docId=###URL###\" /></object>");



function youtube_plugin_callback($match)
{
	$output = YOUTUBE_TARGET;
	$output = str_replace("###URL###", $match[1], $output);
	return ($output);
}

function youtube_plugin($content)
{
	return (preg_replace_callback(YOUTUBE_REGEXP, 'youtube_plugin_callback', $content));
}




function GoogleVideo_plugin_callback($match)
{
	$output = GoogleVideo_TARGET;
	$output = str_replace("###URL###", $match[1], $output);
	return ($output);
}

function GoogleVideo_plugin($content)
{
	return (preg_replace_callback(GoogleVideo_REGEXP, 'GoogleVideo_plugin_callback', $content));
}


add_filter('the_content', 'youtube_plugin');
add_filter('comment_text', 'youtube_plugin');
add_filter('the_content', 'GoogleVideo_plugin');
add_filter('comment_text', 'GoogleVideo_plugin');


?>